package fr.openpeople.test.fibonacci.core.unittest;

import org.junit.Assert;
import org.junit.Test;

import fr.openpeople.test.fibonacci.core.SuiteFibonacci;

import static fr.openpeople.test.fibonacci.core.MethodeCalculFibonacci.*;
import static org.junit.Assert.assertEquals;

/**
 * Classe de tests unitaires pour
 *  fr.openpeople.test.fibonacci.core.SuiteFibonacci.
 * 
 * @author KR
 * @see fr.openpeople.test.fibonacci.core.SuiteFibonacci
 */
public class SuiteFibonacciUnitTester {

	static final int[] valeursRef = {
		// les deux constantes de départ
		0, 1,
		// valeurs connues...
		1, 2, 3, 5, 8, 13, 21, 34, 55, 89,
		144, 233, 377, 610, 987,
		1597, 2584, 4181, 6765,
		10946};

	@Test
	public void test() {
		for (int cpt = 0; cpt <= 21; cpt++){
			long calc =
				(long) SuiteFibonacci.calculerFibonacci(cpt, CALCUL_ITERATIF);
			Assert.assertEquals(valeursRef[cpt], calc);
		}

		for (int cpt = 0; cpt <= 21; cpt++){
			long calc = Math.round(SuiteFibonacci.calculerFibonacci(
					cpt,
					CALCUL_FONCTIONNEL));
			Assert.assertEquals(valeursRef[cpt], calc);
		}
		long fibo50 = Math.round(SuiteFibonacci.calculerFibonacci(
				50,
				CALCUL_FONCTIONNEL));
		assertEquals("Problème avec calculerFibonacciFonc(50)",
				12586269025l,
				fibo50);
		long fibo71 = Math.round(SuiteFibonacci.calculerFibonacci(
				71,
				CALCUL_FONCTIONNEL));
		assertEquals("Problème avec calculerFibonacciFonc(71)",
				308061521170130l,
				fibo71);
	}

}
