package fr.openpeople.test.fibonacci.guitest;

import static org.eclipse.swtbot.swt.finder.SWTBotAssert.assertContains;
import static org.eclipse.swtbot.swt.finder.SWTBotAssert.assertDoesNotContain;

import org.eclipse.swtbot.eclipse.finder.SWTWorkbenchBot;
import org.junit.Test;

public class FibonacciGuiTest {

	private static final String TARGET_VIEW_ID =
		"fr.openpeople.test.fibonacci.view";
	private static final String ITERATIVE_METHOD_RADIO_LABEL =
		"iterative";
	private static final String FUNCTIONAL_METHOD_RADIO_LABEL =
		"fonctionnelle";
	private static final String INPUT_VALUE_LABEL =
		"Entrez le parametre pour lequel vous voulez" +
		" calculer la valeur de la suite de Fibonacci :";
	private static final String CALCULATE_BUTTON_LABEL =
		"Calculer !";
	private static final String RESULTS_GROUP_TITLE =
		"Resultats:";
	private static final String FUNC_METHOD_NOTE =
		"NOTE: la methode de calcul fonctionnelle";   // etc, etc.


	private SWTWorkbenchBot bot = new SWTWorkbenchBot();

	@Test
	public void guiTest() {
		bot.viewById(TARGET_VIEW_ID).show();
		bot.viewById(TARGET_VIEW_ID).setFocus();
		String resTxt;

		bot.spinnerWithLabel(INPUT_VALUE_LABEL).setSelection(0);
		bot.radio(ITERATIVE_METHOD_RADIO_LABEL).click();
		bot.button(CALCULATE_BUTTON_LABEL).click();

		resTxt = bot.textInGroup(RESULTS_GROUP_TITLE).getText();
		assertContains("Fibo(0) = 0", resTxt);
		assertDoesNotContain(FUNC_METHOD_NOTE, resTxt);

		bot.radio(FUNCTIONAL_METHOD_RADIO_LABEL).click();
		bot.button(CALCULATE_BUTTON_LABEL).click();

		resTxt = bot.textInGroup(RESULTS_GROUP_TITLE).getText();
		assertContains("Fibo(0) = 0", resTxt);
		assertContains(FUNC_METHOD_NOTE, resTxt);

		bot.spinnerWithLabel(INPUT_VALUE_LABEL).setSelection(70);
		bot.radio(ITERATIVE_METHOD_RADIO_LABEL).click();
		bot.button(CALCULATE_BUTTON_LABEL).click();

		resTxt = bot.textInGroup(RESULTS_GROUP_TITLE).getText();
		assertContains("Fibo(70) = 190392490709135", resTxt);
		assertDoesNotContain(FUNC_METHOD_NOTE, resTxt);

		bot.radio(FUNCTIONAL_METHOD_RADIO_LABEL).click();
		bot.button(CALCULATE_BUTTON_LABEL).click();

		resTxt = bot.textInGroup(RESULTS_GROUP_TITLE).getText();
		assertContains("Fibo(70) = 190392490709135", resTxt);
		assertContains(FUNC_METHOD_NOTE, resTxt);

		bot.spinnerWithLabel(INPUT_VALUE_LABEL).setSelection(71);
		bot.radio(ITERATIVE_METHOD_RADIO_LABEL).click();
		bot.button(CALCULATE_BUTTON_LABEL).click();

		resTxt = bot.textInGroup(RESULTS_GROUP_TITLE).getText();
		assertContains("Fibo(71) = 308061521170129", resTxt);
		assertDoesNotContain(FUNC_METHOD_NOTE, resTxt);

		bot.radio(FUNCTIONAL_METHOD_RADIO_LABEL).click();
		bot.button(CALCULATE_BUTTON_LABEL).click();

		resTxt = bot.textInGroup(RESULTS_GROUP_TITLE).getText();
		assertContains("Fibo(71) = 308061521170130", resTxt);
		assertContains(FUNC_METHOD_NOTE, resTxt);

		bot.spinnerWithLabel(INPUT_VALUE_LABEL).setSelection(93);
/*		bot.radio(ITERATIVE_METHOD_RADIO_LABEL).click();
		bot.button(CALCULATE_BUTTON_LABEL).click(); */

		bot.radio(FUNCTIONAL_METHOD_RADIO_LABEL).click();
		bot.button(CALCULATE_BUTTON_LABEL).click();

		resTxt = bot.textInGroup(RESULTS_GROUP_TITLE).getText();
		assertContains("Fibo(93) = 12200160415121914000", resTxt);
		assertContains(FUNC_METHOD_NOTE, resTxt);

		bot.spinnerWithLabel(INPUT_VALUE_LABEL).setSelection(100);
		bot.radio(FUNCTIONAL_METHOD_RADIO_LABEL).click();
		bot.button(CALCULATE_BUTTON_LABEL).click();

		resTxt = bot.textInGroup(RESULTS_GROUP_TITLE).getText();
		assertContains("Fibo(100) = 354224848179263100000", resTxt);
		assertContains(FUNC_METHOD_NOTE, resTxt);
	}

}
